//InitGL.cpp

/*
The initiation and drawing functions for 
OpenGL s located in ths file 
*************************
***Group 13 2005***
*************************
*/

#include "unicycle.h"

object o;                   //The psyhical object to simlate
text t;                     //The OpenGL text writer
drawObj obj;                //The drawing function
load ld;                    //The model loader


float vel2=0;               //Velocity of the vehicle
float vinkel=0;             //Angle of the vehicle
float deadAngle = 90;       //Angle when vehicle hits ground
bool alive= true;           //Boolean to indicate if vehicle has fallen

GLuint texture[3];  //Array with textures

//Light variables
GLfloat LightAmbient[]=		{ 0.7f, 0.7f, 0.7f, 1.0f }; //Ambient lightcolor
GLfloat LightDiffuse[]=		{ 0.5f, 0.5f, 0.5f, 1.0f }; //Diffse lightcolor
GLfloat LightPosition[]=	{ 0.2f, 0.2f, 0.2f, 1.0f }; //Positional lightcolor

//Fog effect variables
GLuint filter;						                // Which Filter To Use
GLuint fogMode[]= { GL_EXP, GL_EXP2, GL_LINEAR };	// Storage For Three Types Of Fog
GLfloat fogColor[4]= {0.5f, 0.5f, 0.5f, 1.0f};		// Fog Color



initGL::initGL(void)
{
//konstruktor

}

initGL::~initGL(void)
{
    //destruktor
}


//Resets the simulation
void initGL::reset()
{ 
    vel2=0;
    vinkel=0;
    deadAngle = 90;
    o.resetAll();
    alive= true;
}


//Function for loading textures
//Thanks nehe.gamedev.net
int initGL::LoadGLTextures()						    // Load Bitmaps And Convert To Textures
{
	int Status=FALSE;									// Status Indicator

	AUX_RGBImageRec *TextureImage[1];					// Create Storage Space For The Texture

	memset(TextureImage,0,sizeof(void *)*1);           	// Set The Pointer To NULL

	// Load The Bitmap, Check For Errors, If Bitmap's Not Found Quit
	if (TextureImage[0]=auxDIBImageLoad("models/Mantorp.bmp"))
	{
		Status=TRUE;									// Set The Status To TRUE

		glGenTextures(3, &texture[0]);					// Create Three Textures

		// Create Nearest Filtered Texture
		glBindTexture(GL_TEXTURE_2D, texture[0]);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST);
		glTexImage2D(GL_TEXTURE_2D, 0, 3, TextureImage[0]->sizeX, TextureImage[0]->sizeY, 0, GL_RGB, GL_UNSIGNED_BYTE, TextureImage[0]->data);

		// Create Linear Filtered Texture
		glBindTexture(GL_TEXTURE_2D, texture[1]);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
		glTexImage2D(GL_TEXTURE_2D, 0, 3, TextureImage[0]->sizeX, TextureImage[0]->sizeY, 0, GL_RGB, GL_UNSIGNED_BYTE, TextureImage[0]->data);

		// Create MipMapped Texture
		glBindTexture(GL_TEXTURE_2D, texture[2]);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR_MIPMAP_NEAREST);
		gluBuild2DMipmaps(GL_TEXTURE_2D, 3, TextureImage[0]->sizeX, TextureImage[0]->sizeY, GL_RGB, GL_UNSIGNED_BYTE, TextureImage[0]->data);
	}

	if (TextureImage[0])								// If Texture Exists
	{
		if (TextureImage[0]->data)						// If Texture Image Exists
		{
			free(TextureImage[0]->data);				// Free The Texture Image Memory
		}

		free(TextureImage[0]);							// Free The Image Structure
	}

	return Status;										// Return The Status
}


//Function to change the OpenGl window size
GLvoid initGL::ReSizeGLScene(GLsizei width, GLsizei height)		// Resize And Initialize The GL Window
{
	if (height==0)										// Prevent A Divide By Zero By
	{
		height=1;										// Making Height Equal One
	}

	glViewport(0,0,width,height);						// Reset The Current Viewport
	
	glMatrixMode(GL_PROJECTION);						// Select The Projection Matrix
	glLoadIdentity();									// Reset The Projection Matrix

	// Calculate The Aspect Ratio Of The Window
	gluPerspective(60.0f,(GLfloat)width/(GLfloat)height,0.1f,100.0f);

	glMatrixMode(GL_MODELVIEW);							// Select The Modelview Matrix
	glLoadIdentity();									// Reset The Modelview Matrix
}


// Initiation of OpenGL
int initGL::InitGL(GLvoid)		
{

     ld.Init();      //Loading models
     
     //Loading textures
     if (!LoadGLTextures())					// Jump To Texture Loading Routine
      {
	  return FALSE;							// If Texture Didn't Load Return FALSE
	  }
    
	glShadeModel(GL_SMOOTH);							// Enable Smooth Shading
	glClearColor(1.0f, 1.0f, 1.0f, 1.0f);				// Black Background
	glClearDepth(1.0f);									// Depth Buffer Setup
	glEnable(GL_DEPTH_TEST);							// Enables Depth Testing
	glDepthFunc(GL_LEQUAL);								// The Type Of Depth Testing To Do
	t.BuildFont();										// Build The Font
	
	
	glEnable(GL_TEXTURE_2D);                            //Enables textures
    glEnable(GL_CULL_FACE);                             // Cull away all back facing polygons
    glLightfv(GL_LIGHT1, GL_AMBIENT, LightAmbient);		// Setup The Ambient Light
	glLightfv(GL_LIGHT1, GL_DIFFUSE, LightDiffuse);		// Setup The Diffuse Light
	glLightfv(GL_LIGHT0, GL_DIFFUSE, LightDiffuse);		// Setup The Diffuse Light
	glLightfv(GL_LIGHT2, GL_DIFFUSE, LightDiffuse);		// Setup The Diffuse Light
 	glEnable(GL_LIGHT1);								// Enable Light One
 	glEnable(GL_LIGHT0);		                        // Enable Light Zero
    
    glFogi(GL_FOG_MODE, fogMode[0]);		            // Fog Mode
    glFogfv(GL_FOG_COLOR, fogColor);        			// Set Fog Color
    glFogf(GL_FOG_DENSITY, 0.03f);				        // How Dense Will The Fog Be
    glHint(GL_FOG_HINT, GL_DONT_CARE);	        		// Fog Hint Value
    glFogf(GL_FOG_START, 15.0f);			        	// Fog Start Depth
    glFogf(GL_FOG_END, 20.0f);				            // Fog End Depth
    glEnable(GL_FOG);		                			// Enables GL_FOG
   
  	
	glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);	// Really Nice Perspective Calculations     
    return TRUE;										// Initialization Went OK
}

//Draws each frame
int initGL::DrawGLScene(GLvoid)							
{

    glClearColor(0.5f,0.5f,0.5f,1.0f);		        	// We'll Clear To The Color Of The Fog ( Modified )

    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);	// Clear Screen And Depth Buffer
	
    glDisable(GL_LIGHTING);                             //Disable lighting to get correct text color
	
    glColor3f(0.2f,0.2f,0.2f);		                	// Set The Color To Red

    glLoadIdentity();									// Reset The Current Modelview Matrix  
    glTranslatef(0.0f,0.0f,-6.0f);				        // Left 1.5 Then Into Screen Six Units	
 
//If the angle is smaller than Deadangle will the next state be calculated
if(vinkel < deadAngle && vinkel > -deadAngle)
 {
  vinkel = o.bend();
  vel2 = o.move();
}		
//If the angle is larger will the simulation stop
else {
  vel2=0.0f;
  glRasterPos2f(-3.0f, 2.6f);
  t.glPrint("Du suger pa att aka segway!");
  glRasterPos2f(-2.0f, 2.2f);
  t.glPrint("(tryck mellanslag)");
  alive=false;
}

    //The angle and speed is display in text on the screen each frame
    glRasterPos2f(-4.5f, 3.2f);
    t.glPrint("Vinkel:");	         // Print GL Text To The Screen
    glRasterPos2f(-4.3f, 2.8f);
    t.glPrint("%4.2f", vinkel);	 // Print GL Text To The Screen
    glRasterPos2f(3.2f, 3.2f);
    t.glPrint("Km/h:");	         // Print GL Text To The Screen
    glRasterPos2f(3.2f, 2.8f);
    t.glPrint("%4.2f", vel2);	     // Print GL Text To The Screen
    
    
    glLoadIdentity();					// Reset The Current Modelview Matrix
    glEnable(GL_LIGHTING);              //Enable lighting 
	glEnable(GL_TEXTURE_2D);            //Enable Textures 
    
    obj.drawScene(vel2, vinkel, radie); //Call the draw class to draw the model
       
        
    return TRUE;						// Everything Went OK
}

