//drawObj.cpp

/*
The tranformations and functions for drawing 
a plane is located in this file.
*************************
***Group 13 2005***
*************************
*/

#include "unicycle.h"

/******extern klasses *******/
extern load ld;             //ASE file loading
extern GLuint texture[3];
extern GLfloat LightPosition[];

/**2-d vectors of the moving direction in the horisontal plane**/
float newPos[2]={0.0f,0.0f};

/***************variables that control turns***************/
extern float hjulrot;        //the direction in which the vehicle turns
extern bool svangV,svangH;   //flags to show if it turns left or right
float vVanster, vHoger;     //velocities of each wheel, new and old
float newVHoger,newVVanster; 
float svangRadie;           //how sharp the turn is


extern bool modelbyte;      //just for fun!

drawObj::drawObj(void)
{

}

drawObj::~drawObj(void)
{

}


void drawObj::drawScene(float p,float v,float rad) //p=position, v=velociry, rad=
{
    //move the vehicle forward
    newPos[0]+= p*dt*sin(hjulrot*gradToRad);
    newPos[1]-= p*dt*cos(hjulrot*gradToRad);

    //Make the camera follow after!
    gluLookAt( newPos[0]+3, 4.0f, newPos[1],    // Eye position
               newPos[0], 1.0f, newPos[1]-6.0f,   // View point
                0.0f, 1.0f, 0.0f );  // Up vector	
                
    //Place light
    glPushMatrix();
    glTranslatef(0.0f,10.0f,0.0f);  
    glLightfv(GL_LIGHT1, GL_POSITION,LightPosition);	// Position The Light
    glTranslatef(-50.0f,0.0f,-50.0f);  
    glLightfv(GL_LIGHT0, GL_POSITION,LightPosition);	// Position The Light
    glPopMatrix();

    //load texture on plane (landscape)
    glEnable(GL_LIGHT2);		
    glBindTexture(GL_TEXTURE_2D, texture[2]); // Use texture
    drawTextPlane(200,200);                    //Posistion the plane
    glDisable(GL_LIGHT2);
    glTranslatef(0,radie+0.1,-6.0f);           //Positions the startpoint of segway

    //check of the left or right arrows are down (from openwindow.cpp)

if(svangV || svangH)//do you want to turn?    
    {    
    float vMitt = p; //velocity in the middle of the axis

    /***arbitrary formula for the sharpness of the turn
    NB! as it is now its only valid for foward movement!****/
    svangRadie =abs(0.2*p+axel); 

    float omega= vMitt/(svangRadie+ axel/2); //angular velocity of the turn


   /***calculate each individual speed for each wheel and the overall turn for the bike,
   depending on the bool:s****/
   if(svangV){
   hjulrot-=dt*radToGrad*omega;
   vVanster=omega*svangRadie;
   vHoger=omega*(svangRadie+axel);
   }
   else{
   hjulrot+=dt*radToGrad*omega;
   vHoger=omega*svangRadie;
   vVanster=omega*(svangRadie+axel);
   }
   
   if(hjulrot>360 ||hjulrot < -360)hjulrot=0; //zero after one revolution
}//end of if

else //no turns this time
    {
    vHoger=p;
    vVanster=p;
    }

//Simulate the wheels now
    newVVanster+=dt*vVanster/radie;                     
    if(newVVanster>2*pi ||newVVanster < -2*pi)newVVanster=0; //zero after one revolution
    newVHoger+=dt*vHoger/radie;
    if(newVHoger>2*pi ||newVHoger < -2*pi)newVHoger=0;

//translate to the new positions
  glTranslatef(newPos[0],0.0f,newPos[1]);          
  glRotatef((-hjulrot)+90.0f,0.0f,1.0f,0.0f);    //minus for the right side 
      
    /***the following code draws the vehicle on screen*****/    
    glPushMatrix();
      glRotatef(-v,0.0f,0.0f,1.0f);
      glScalef(0.05,0.05,0.057);      
      glRotatef(-180,0.0f,1.0f,0.0f);
      ld.RenderScene(0);                //Calls ASE loader to draw Segway base
      if(modelbyte) ld.RenderScene(2);  //Calls ASE loader to draw driver 
      else ld.RenderScene(3);
   glPopMatrix();
    
    glColor3f(0,0,0);
    
    //Right wheel
    glPushMatrix();  
      glRotatef(-radToGrad*newVHoger,0.0f,0.0f,1.0f);    
      glTranslatef(0.0f,0.0f,axel); 
      glScalef(0.05,0.05,0.05);
      ld.RenderScene(1);     //Calls ASE loader to draw the wheel

    //Left wheel
    glPopMatrix();
      glRotatef(-radToGrad*newVVanster,0.0f,0.0f,1.0f);    
      glTranslatef(0.0f,0.0f,-axel);
       glScalef(0.05,0.05,0.05);
      ld.RenderScene(1);  //Calls ASE loader to draw the wheel

    /***end of drawing****/
}
      

//Draws one polygon with a texture mapping
void drawObj::drawTextPlane(float x,float y) {
  float i, j;
  int plattSt=4;
    glColor3f(1,1,1);
    glBegin(GL_QUADS);
    glNormal3f(0,1,0);
    glTexCoord2f(0,0);   glVertex3f(x,0,y);
    glTexCoord2f(1,0);   glVertex3f(x,0,-y);
    glTexCoord2f(1,1);   glVertex3f(-x,0,-y);
    glTexCoord2f(0,1);   glVertex3f(-x,0,y);
  glEnd();
}


